/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse prosparse
#define yylex   proslex
#define yyerror proserror
#define yylval  proslval
#define yychar  proschar
#define yydebug prosdebug
#define yynerrs prosnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INT = 258,
     REAL = 259,
     STRING = 260,
     HOUR = 261,
     MINUTE = 262,
     SECOND = 263,
     DEGREE = 264,
     ARCMINUTE = 265,
     ARCSECOND = 266,
     RADIAN = 267,
     SEXSTR = 268,
     EOF_ = 269,
     ANNULUS_ = 270,
     B1950_ = 271,
     BOX_ = 272,
     CIRCLE_ = 273,
     DEBUG_ = 274,
     ECLIPTIC_ = 275,
     ELLIPSE_ = 276,
     EQUATORIAL_ = 277,
     GALACTIC_ = 278,
     J2000_ = 279,
     LOGICAL_ = 280,
     N_ = 281,
     OFF_ = 282,
     ON_ = 283,
     PHYSICAL_ = 284,
     POINT_ = 285,
     POLYGON_ = 286,
     ROTBOX_ = 287,
     VERSION_ = 288
   };
#endif
#define INT 258
#define REAL 259
#define STRING 260
#define HOUR 261
#define MINUTE 262
#define SECOND 263
#define DEGREE 264
#define ARCMINUTE 265
#define ARCSECOND 266
#define RADIAN 267
#define SEXSTR 268
#define EOF_ 269
#define ANNULUS_ 270
#define B1950_ 271
#define BOX_ 272
#define CIRCLE_ 273
#define DEBUG_ 274
#define ECLIPTIC_ 275
#define ELLIPSE_ 276
#define EQUATORIAL_ 277
#define GALACTIC_ 278
#define J2000_ 279
#define LOGICAL_ 280
#define N_ 281
#define OFF_ 282
#define ON_ 283
#define PHYSICAL_ 284
#define POINT_ 285
#define POLYGON_ 286
#define ROTBOX_ 287
#define VERSION_ 288




/* Copy the first part of user declarations.  */
#line 5 "prosparser.Y"

#define YYPARSE_PARAM fr
#define YYDEBUG 1

#define FR ((FrameBase*)fr)
#define FITPTR (FR->findFits(1))

#define DISCARD_(x) {yyclearin; prosDiscard(x);}

#include <math.h>
#include <string.h>
#include <iostream.h>

#include "framebase.h"
#include "fitsimage.h"
#include "util.h"
#include "vector.h"
#include "list.h"
#include "basemarker.h"
#include "coord.h"

extern int proslex(void);
extern void proserror(const char*);
extern void prosDiscard(int);

int prossign;
int prossign2;

static CoordSystem globalSystem;
static SkyFrame globalSky;
static CoordSystem localSystem;
static SkyFrame localSky;

static unsigned short globalProps;
static unsigned short localProps;

static char *color = "green";
static char *font = "helvetica 10 normal";
static char *text = "";

static char localComment[80];

static List<Vertex> polylist;
static List<Tag> taglist;
static List<CallBack> cblist;

static double aAnnuli[MAXANNULI];
static Vector aVector[MAXANNULI];
static int aNum;
static int aStatus;
static Vector aCenter;
static double aAngle;
static unsigned short aProps;
static char aComment[80];

static void setProps(unsigned short* props, unsigned short prop, int value);
static CoordSystem checkWCSSystem();
static SkyFrame checkWCSSky();


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 65 "prosparser.Y"
typedef union YYSTYPE {
  double real;
  int integer;
  char str[2048];
  double vector[3];
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 218 "prosparser.C"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 230 "prosparser.C"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   229

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  45
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  41
/* YYNRULES -- Number of rules. */
#define YYNRULES  90
/* YYNRULES -- Number of states. */
#define YYNSTATES  195

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   288

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      34,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    43,     2,    44,     2,     2,    42,     2,
      37,    38,     2,    40,    36,    41,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    35,
       2,    39,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     7,    11,    14,    15,    18,    20,    21,
      25,    26,    30,    34,    36,    38,    40,    42,    44,    46,
      48,    50,    51,    53,    54,    56,    57,    59,    60,    62,
      64,    66,    68,    70,    72,    74,    76,    80,    84,    88,
      92,    96,    98,   102,   103,   112,   113,   122,   126,   130,
     132,   134,   137,   139,   141,   143,   145,   147,   149,   150,
     151,   152,   154,   156,   164,   174,   175,   188,   200,   210,
     229,   239,   249,   268,   274,   275,   282,   286,   288,   290,
     294,   296,   298,   299,   300,   301,   305,   306,   310,   312,
     313
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      46,     0,    -1,    69,    47,    79,    -1,    47,    48,    51,
      -1,    48,    51,    -1,    -1,    19,    53,    -1,    33,    -1,
      -1,    66,    49,    80,    -1,    -1,    67,    50,    80,    -1,
      70,    71,    72,    -1,    82,    -1,    34,    -1,    35,    -1,
      14,    -1,     4,    -1,     3,    -1,    28,    -1,    27,    -1,
      -1,    36,    -1,    -1,    37,    -1,    -1,    38,    -1,    -1,
      58,    -1,    52,    -1,     9,    -1,    12,    -1,    52,    -1,
       9,    -1,    10,    -1,    11,    -1,    52,    54,    52,    -1,
       9,    54,     9,    -1,    10,    54,    10,    -1,    11,    54,
      11,    -1,    26,    39,     3,    -1,    13,    -1,    62,    54,
      62,    -1,    -1,     6,     7,     8,    64,    54,     3,    10,
      11,    -1,    -1,     3,    10,    11,    65,    54,     3,    10,
      11,    -1,    52,    54,    52,    -1,     9,    54,     9,    -1,
      25,    -1,    29,    -1,    22,    68,    -1,    16,    -1,    24,
      -1,    23,    -1,    20,    -1,    16,    -1,    24,    -1,    -1,
      -1,    -1,    40,    -1,    41,    -1,    18,    55,    63,    54,
      59,    56,    84,    -1,    15,    55,    63,    54,    59,    54,
      59,    56,    84,    -1,    -1,    15,    55,    63,    54,    59,
      54,    59,    54,    73,    77,    56,    84,    -1,    15,    55,
      63,    54,    59,    54,    59,    54,    61,    56,    84,    -1,
      21,    55,    63,    54,    60,    54,    57,    56,    84,    -1,
      21,    55,    63,    54,    60,    54,    57,    56,    42,    43,
      21,    55,    63,    54,    60,    54,    57,    56,    -1,    17,
      55,    63,    54,    60,    54,    57,    56,    84,    -1,    32,
      55,    63,    54,    60,    54,    57,    56,    84,    -1,    17,
      55,    63,    54,    60,    54,    57,    56,    42,    43,    17,
      55,    63,    54,    60,    54,    57,    56,    -1,    30,    55,
      63,    56,    84,    -1,    -1,    31,    74,    55,    75,    56,
      84,    -1,    75,    54,    76,    -1,    76,    -1,    63,    -1,
      77,    54,    78,    -1,    78,    -1,    59,    -1,    -1,    -1,
      -1,    44,    81,     5,    -1,    -1,    44,    83,     5,    -1,
      79,    -1,    -1,    44,    85,     5,    79,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   123,   123,   126,   127,   130,   131,   132,   133,   133,
     134,   134,   135,   136,   139,   140,   141,   144,   145,   148,
     149,   152,   153,   156,   157,   160,   161,   164,   165,   168,
     169,   170,   173,   174,   175,   176,   179,   186,   193,   200,
     209,   212,   215,   229,   229,   239,   239,   250,   257,   267,
     268,   271,   272,   273,   274,   275,   278,   279,   282,   293,
     302,   303,   304,   308,   312,   316,   316,   325,   330,   346,
     353,   369,   374,   381,   385,   385,   390,   391,   394,   397,
     398,   401,   405,   432,   433,   433,   436,   436,   439,   440,
     440
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INT", "REAL", "STRING", "HOUR",
  "MINUTE", "SECOND", "DEGREE", "ARCMINUTE", "ARCSECOND", "RADIAN",
  "SEXSTR", "EOF_", "ANNULUS_", "B1950_", "BOX_", "CIRCLE_", "DEBUG_",
  "ECLIPTIC_", "ELLIPSE_", "EQUATORIAL_", "GALACTIC_", "J2000_",
  "LOGICAL_", "N_", "OFF_", "ON_", "PHYSICAL_", "POINT_", "POLYGON_",
  "ROTBOX_", "VERSION_", "'\\n'", "';'", "','", "'('", "')'", "'='", "'+'",
  "'-'", "'&'", "'!'", "'#'", "$accept", "start", "commands", "command",
  "@1", "@2", "terminator", "numeric", "debug", "sp", "bp", "ep",
  "optangle", "angle", "value", "vvalue", "numberof", "sexagesimal",
  "coord", "@3", "@4", "coordSystem", "skyFrame", "equatorial",
  "initGlobal", "initLocal", "include", "shape", "@5", "@6", "polyNodes",
  "polyNode", "aRads", "aRad", "processAnnulus", "comment", "@7",
  "generalComment", "@8", "shapeComment", "@9", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    10,    59,    44,    40,    41,    61,
      43,    45,    38,    33,    35
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    45,    46,    47,    47,    48,    48,    48,    49,    48,
      50,    48,    48,    48,    51,    51,    51,    52,    52,    53,
      53,    54,    54,    55,    55,    56,    56,    57,    57,    58,
      58,    58,    59,    59,    59,    59,    60,    60,    60,    60,
      61,    62,    63,    64,    63,    65,    63,    63,    63,    66,
      66,    67,    67,    67,    67,    67,    68,    68,    69,    70,
      71,    71,    71,    72,    72,    73,    72,    72,    72,    72,
      72,    72,    72,    72,    74,    72,    75,    75,    76,    77,
      77,    78,    79,    80,    81,    80,    83,    82,    84,    85,
      84
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     3,     3,     2,     0,     2,     1,     0,     3,
       0,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     0,     1,     0,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     1,     3,     0,     8,     0,     8,     3,     3,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     0,     0,
       0,     1,     1,     7,     9,     0,    12,    11,     9,    18,
       9,     9,    18,     5,     0,     6,     3,     1,     1,     3,
       1,     1,     0,     0,     0,     3,     0,     3,     1,     0,
       4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
      58,     0,    59,     1,    52,     0,    55,     0,    54,    53,
      49,    50,     7,    86,    59,     0,     8,    10,    60,    13,
      20,    19,     6,    56,    57,    51,     0,     0,     2,    16,
      14,    15,     4,    83,    83,    61,    62,     0,    87,     3,
      84,     9,    11,    23,    23,    23,    23,    23,    74,    23,
      12,     0,    24,     0,     0,     0,     0,     0,    23,     0,
      85,    18,    17,     0,    21,    41,    21,    21,    21,    21,
      21,    21,    25,     0,    21,     0,     0,    22,     0,     0,
       0,     0,     0,     0,     0,    26,    82,    78,    21,    77,
       0,    45,    43,    48,    18,    47,    42,    33,    34,    35,
      32,    21,    21,    21,    21,    21,    21,    25,    21,    89,
      88,    73,     0,    82,    21,    21,    21,     0,     0,     0,
       0,     0,    27,    82,    27,     0,    76,    75,    27,     0,
       0,    21,    37,    38,    39,    36,    30,    31,    29,    25,
      28,    63,    25,    82,    25,     0,     0,    65,    82,    82,
      82,    90,    82,     0,     0,     0,    25,     0,    64,     0,
      70,     0,    68,    71,    46,    44,     0,    82,    81,    21,
      80,     0,     0,    40,    67,     0,    82,    23,    23,    79,
      66,     0,     0,    21,    21,     0,     0,    21,    21,    27,
      27,    25,    25,    72,    69
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,    14,    15,    33,    34,    32,    66,    22,    78,
      53,    86,   139,   140,   168,   106,   156,    67,    87,   116,
     115,    16,    17,    25,     2,    18,    37,    50,   157,    58,
      88,    89,   169,   170,   110,    41,    51,    19,    26,   111,
     125
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -110
static const short yypact[] =
{
    -110,    20,   185,  -110,  -110,     4,  -110,    18,  -110,  -110,
    -110,  -110,  -110,  -110,   162,    14,  -110,  -110,    -5,  -110,
    -110,  -110,  -110,  -110,  -110,  -110,    25,    14,  -110,  -110,
    -110,  -110,  -110,     2,     2,  -110,  -110,    57,  -110,  -110,
    -110,  -110,  -110,    31,    31,    31,    31,    31,  -110,    31,
    -110,    46,  -110,    88,    88,    88,    88,    88,    31,    88,
    -110,    45,  -110,    70,    43,  -110,    43,    43,    43,    43,
      43,    43,    47,    88,    43,    73,    82,  -110,    84,    79,
      83,    99,   150,    99,   150,  -110,    54,  -110,     3,  -110,
     150,  -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,
    -110,    43,    43,    43,    43,    43,    43,    47,    43,  -110,
    -110,  -110,    88,    54,    43,    43,    43,    99,    90,    96,
     102,    79,    41,    54,    41,   109,  -110,  -110,    41,   112,
     113,     3,  -110,  -110,  -110,  -110,  -110,  -110,  -110,    47,
    -110,  -110,    47,  -110,    47,   107,   108,    94,    54,   -26,
      10,  -110,    54,   110,   114,    87,    47,    99,  -110,    80,
    -110,   103,  -110,  -110,  -110,  -110,   128,    54,  -110,     3,
    -110,   120,   124,  -110,  -110,    99,    54,    31,    31,  -110,
    -110,    88,    88,    43,    43,   150,   150,    43,    43,    41,
      41,    47,    47,  -110,  -110
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -110,  -110,  -110,   136,  -110,  -110,   125,   -17,  -110,   -45,
     -44,   -12,  -109,  -110,   -77,   -57,  -110,    75,   -46,  -110,
    -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,
    -110,    44,  -110,   -11,    -2,   129,  -110,  -110,  -110,    -1,
    -110
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -83
static const short yytable[] =
{
      54,    55,    56,    57,   101,    59,   107,    68,    69,    70,
      71,    72,    28,    74,    73,   142,   159,   -25,   109,   144,
       3,    79,    80,    81,    82,    83,    84,   108,    29,    90,
      38,    20,    21,   114,    23,    35,    36,   -25,   -25,    77,
     131,    85,    24,   112,    94,    62,    40,   -25,    30,    31,
     136,    60,   161,   137,   109,    75,   117,   118,   119,   120,
     121,   122,    95,   124,   100,   105,   100,   105,    52,   128,
     129,   130,    43,   105,    44,    45,   113,    76,    46,    77,
     191,   192,    94,    62,    91,    85,   147,    47,    48,    49,
      92,    61,    62,    93,    63,   123,    65,    64,   109,   132,
     100,    65,    94,    62,   135,   138,   133,   138,    97,    98,
      99,   138,   127,   134,   143,   145,   146,   153,   154,   148,
     155,   164,   141,   171,   175,   165,   166,   149,   187,   188,
     150,   173,   152,   181,   182,   183,   184,   177,   185,   186,
     100,   151,   189,   190,   167,   178,   172,   158,   160,   162,
      27,   163,    39,    94,    62,    96,   126,   176,   100,   102,
     103,   104,   -82,    42,   179,     0,   174,     0,   105,   105,
       0,     0,   138,   138,     0,   180,    -5,     0,     4,   193,
     194,     5,     6,     0,     7,     8,     9,    10,     0,     0,
       0,    11,     0,     0,     0,    12,    -5,    -5,     0,    -5,
       0,     4,     0,     0,     5,     6,    13,     7,     8,     9,
      10,     0,     0,     0,    11,     0,     0,     0,    12,    -5,
      -5,     0,     0,     0,     0,     0,     0,     0,     0,    13
};

static const short yycheck[] =
{
      44,    45,    46,    47,    81,    49,    83,    53,    54,    55,
      56,    57,    14,    59,    58,   124,    42,    14,    44,   128,
       0,    66,    67,    68,    69,    70,    71,    84,    14,    74,
       5,    27,    28,    90,    16,    40,    41,    34,    35,    36,
     117,    38,    24,    88,     3,     4,    44,    44,    34,    35,
       9,     5,    42,    12,    44,    10,   101,   102,   103,   104,
     105,   106,    79,   108,    81,    82,    83,    84,    37,   114,
     115,   116,    15,    90,    17,    18,    88,     7,    21,    36,
     189,   190,     3,     4,    11,    38,   131,    30,    31,    32,
       8,     3,     4,     9,     6,   107,    13,     9,    44,     9,
     117,    13,     3,     4,   121,   122,    10,   124,     9,    10,
      11,   128,   113,    11,     5,     3,     3,    10,    10,   131,
      26,    11,   123,    43,   169,    11,    39,   139,   185,   186,
     142,     3,   144,   177,   178,   181,   182,    17,   183,   184,
     157,   143,   187,   188,   156,    21,    43,   148,   149,   150,
      14,   152,    27,     3,     4,    80,   112,   169,   175,     9,
      10,    11,     0,    34,   175,    -1,   167,    -1,   185,   186,
      -1,    -1,   189,   190,    -1,   176,    14,    -1,    16,   191,
     192,    19,    20,    -1,    22,    23,    24,    25,    -1,    -1,
      -1,    29,    -1,    -1,    -1,    33,    34,    35,    -1,    14,
      -1,    16,    -1,    -1,    19,    20,    44,    22,    23,    24,
      25,    -1,    -1,    -1,    29,    -1,    -1,    -1,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    46,    69,     0,    16,    19,    20,    22,    23,    24,
      25,    29,    33,    44,    47,    48,    66,    67,    70,    82,
      27,    28,    53,    16,    24,    68,    83,    48,    79,    14,
      34,    35,    51,    49,    50,    40,    41,    71,     5,    51,
      44,    80,    80,    15,    17,    18,    21,    30,    31,    32,
      72,    81,    37,    55,    55,    55,    55,    55,    74,    55,
       5,     3,     4,     6,     9,    13,    52,    62,    63,    63,
      63,    63,    63,    55,    63,    10,     7,    36,    54,    54,
      54,    54,    54,    54,    54,    38,    56,    63,    75,    76,
      54,    11,     8,     9,     3,    52,    62,     9,    10,    11,
      52,    59,     9,    10,    11,    52,    60,    59,    60,    44,
      79,    84,    54,    56,    60,    65,    64,    54,    54,    54,
      54,    54,    54,    56,    54,    85,    76,    84,    54,    54,
      54,    59,     9,    10,    11,    52,     9,    12,    52,    57,
      58,    84,    57,     5,    57,     3,     3,    54,    56,    56,
      56,    79,    56,    10,    10,    26,    61,    73,    84,    42,
      84,    42,    84,    84,    11,    11,    39,    56,    59,    77,
      78,    43,    43,     3,    84,    54,    56,    17,    21,    78,
      84,    55,    55,    63,    63,    54,    54,    60,    60,    54,
      54,    57,    57,    56,    56
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 132 "prosparser.Y"
    {cerr << "PROS" << endl;;}
    break;

  case 8:
#line 133 "prosparser.Y"
    {globalSystem = (CoordSystem)yyvsp[0].integer;;}
    break;

  case 10:
#line 134 "prosparser.Y"
    {globalSystem = WCS; globalSky = (SkyFrame)yyvsp[0].integer;;}
    break;

  case 16:
#line 141 "prosparser.Y"
    {YYACCEPT;;}
    break;

  case 17:
#line 144 "prosparser.Y"
    {yyval.real=yyvsp[0].real;;}
    break;

  case 18:
#line 145 "prosparser.Y"
    {yyval.real=yyvsp[0].integer;;}
    break;

  case 19:
#line 148 "prosparser.Y"
    {yydebug=1;;}
    break;

  case 20:
#line 149 "prosparser.Y"
    {yydebug=0;;}
    break;

  case 27:
#line 164 "prosparser.Y"
    {yyval.real = 0;;}
    break;

  case 28:
#line 165 "prosparser.Y"
    {yyval.real = yyvsp[0].real;;}
    break;

  case 29:
#line 168 "prosparser.Y"
    {yyval.real = degToRad(yyvsp[0].real);;}
    break;

  case 30:
#line 169 "prosparser.Y"
    {yyval.real = degToRad(yyvsp[0].real);;}
    break;

  case 31:
#line 170 "prosparser.Y"
    {yyval.real=yyvsp[0].real;;}
    break;

  case 32:
#line 173 "prosparser.Y"
    {yyval.real = FITPTR->mapLenToRef(yyvsp[0].real, IMAGE);;}
    break;

  case 33:
#line 174 "prosparser.Y"
    {yyval.real = FITPTR->mapLenToRef(yyvsp[0].real, checkWCSSystem(), DEGREES);;}
    break;

  case 34:
#line 175 "prosparser.Y"
    {yyval.real = FITPTR->mapLenToRef(yyvsp[0].real, checkWCSSystem(), ARCMIN);;}
    break;

  case 35:
#line 176 "prosparser.Y"
    {yyval.real = FITPTR->mapLenToRef(yyvsp[0].real, checkWCSSystem(), ARCSEC);;}
    break;

  case 36:
#line 180 "prosparser.Y"
    {
	  Vector r = FITPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real), IMAGE);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 37:
#line 187 "prosparser.Y"
    {
	  Vector r=FITPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real),checkWCSSystem(),DEGREES);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 38:
#line 194 "prosparser.Y"
    {
	  Vector r=FITPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real),checkWCSSystem(),ARCMIN);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 39:
#line 201 "prosparser.Y"
    {
	  Vector r=FITPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real),checkWCSSystem(),ARCSEC);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 40:
#line 209 "prosparser.Y"
    {yyval.integer = yyvsp[0].integer;;}
    break;

  case 41:
#line 212 "prosparser.Y"
    {yyval.real = parseDMS(yyvsp[0].str);;}
    break;

  case 42:
#line 216 "prosparser.Y"
    {
	  Vector r;
	  CoordSystem sys = checkWCSSystem();
	  SkyFrame sky = checkWCSSky();
	  if (sky == GALACTIC || sky == ECLIPTIC) 
	    r = FITPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), sys, sky);
	  else
	    r = FITPTR->mapToRef(Vector(yyvsp[-2].real*360./24.,yyvsp[0].real), sys, sky);

	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 43:
#line 229 "prosparser.Y"
    {prossign2 = prossign;;}
    break;

  case 44:
#line 230 "prosparser.Y"
    {
	  Vector r = FITPTR->mapToRef(
	    Vector(hmsToDegree(prossign2,yyvsp[-7].integer,yyvsp[-6].integer,yyvsp[-5].real), 
	    dmsToDegree(prossign,yyvsp[-2].integer,yyvsp[-1].real,yyvsp[0].real)),
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 45:
#line 239 "prosparser.Y"
    {prossign2 = prossign;;}
    break;

  case 46:
#line 241 "prosparser.Y"
    {
	  Vector r = FITPTR->mapToRef(
	    Vector(dmsToDegree(prossign2,yyvsp[-7].integer,yyvsp[-6].real,yyvsp[-5].real),
	    dmsToDegree(prossign,yyvsp[-2].integer,yyvsp[-1].real,yyvsp[0].real)),
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 47:
#line 251 "prosparser.Y"
    {
	  Vector r = FITPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), localSystem, localSky);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 48:
#line 258 "prosparser.Y"
    {
	  Vector r = FITPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real),
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;}
    break;

  case 49:
#line 267 "prosparser.Y"
    {yyval.integer = IMAGE;;}
    break;

  case 50:
#line 268 "prosparser.Y"
    {yyval.integer = PHYSICAL;;}
    break;

  case 51:
#line 271 "prosparser.Y"
    {yyval.integer = yyvsp[0].integer;;}
    break;

  case 52:
#line 272 "prosparser.Y"
    {yyval.integer = FK4;;}
    break;

  case 53:
#line 273 "prosparser.Y"
    {yyval.integer = FK5;;}
    break;

  case 54:
#line 274 "prosparser.Y"
    {yyval.integer = GALACTIC;;}
    break;

  case 55:
#line 275 "prosparser.Y"
    {yyval.integer = ECLIPTIC;;}
    break;

  case 56:
#line 278 "prosparser.Y"
    {yyval.integer = FK4;;}
    break;

  case 57:
#line 279 "prosparser.Y"
    {yyval.integer = FK5;;}
    break;

  case 58:
#line 282 "prosparser.Y"
    {
	  // global properties
	  globalSystem = IMAGE;
	  globalSky = NATIVEWCS;
	  globalProps =
	    Marker::SELECT | Marker::EDIT | Marker::MOVE |
	    Marker::ROTATE | Marker::DELETE | Marker::HIGHLITE |
	    Marker::INCLUDE | Marker::SOURCE;
	;}
    break;

  case 59:
#line 293 "prosparser.Y"
    {
	  // global properties
	  localSystem = globalSystem;
	  localSky = globalSky;
	  localProps = globalProps;
	  strcpy(localComment,"");
	;}
    break;

  case 60:
#line 302 "prosparser.Y"
    {setProps(&localProps, Marker::INCLUDE, 1);;}
    break;

  case 61:
#line 303 "prosparser.Y"
    {setProps(&localProps, Marker::INCLUDE, 1);;}
    break;

  case 62:
#line 304 "prosparser.Y"
    {setProps(&localProps, Marker::INCLUDE, 0);;}
    break;

  case 63:
#line 309 "prosparser.Y"
    {FR->createCircleCmd(Vector(yyvsp[-4].vector),
	     yyvsp[-2].real,
	     color,1,font,text,localProps,localComment,taglist,cblist);;}
    break;

  case 64:
#line 313 "prosparser.Y"
    {FR->createAnnulusCmd(Vector(yyvsp[-6].vector),
	    yyvsp[-4].real,yyvsp[-2].real,1,
	    color,1,font,text,localProps,localComment,taglist,cblist);;}
    break;

  case 65:
#line 316 "prosparser.Y"
    {aNum=2;;}
    break;

  case 66:
#line 318 "prosparser.Y"
    {
	  aAnnuli[0] = yyvsp[-7].real;
	  aAnnuli[1] = yyvsp[-5].real;
	  FR->createAnnulusCmd(Vector(yyvsp[-9].vector),
	    aNum,aAnnuli,
	    color,1,font,text,localProps,localComment,taglist,cblist);
	;}
    break;

  case 67:
#line 326 "prosparser.Y"
    {FR->createAnnulusCmd(Vector(yyvsp[-8].vector),
	    yyvsp[-6].real,yyvsp[-4].real,yyvsp[-2].integer,
	    color,1,font,text,localProps,localComment,taglist,cblist);;}
    break;

  case 68:
#line 331 "prosparser.Y"
    {
	  // for ellipse annulus
	  aStatus = 1;
	  aCenter = Vector(yyvsp[-6].vector);
	  aAngle = yyvsp[-2].real;
	  aVector[0] = Vector(yyvsp[-4].vector);
	  aNum = 1;
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  FR->createEllipseCmd(Vector(yyvsp[-6].vector),
	    Vector(yyvsp[-4].vector),
	    yyvsp[-2].real,
	    color,1,font,text,localProps,localComment,taglist,cblist);
	;}
    break;

  case 69:
#line 348 "prosparser.Y"
    {	
	  aStatus = 2;
	  aVector[aNum++] = Vector(yyvsp[-13].vector);
	;}
    break;

  case 70:
#line 354 "prosparser.Y"
    {
	  // for box annulus
	  aStatus = 3;
	  aCenter = Vector(yyvsp[-6].vector);
	  aAngle = yyvsp[-2].real;
	  aVector[0] = Vector(yyvsp[-4].vector);
	  aNum = 1;
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  FR->createBoxCmd(Vector(yyvsp[-6].vector),
	    Vector(yyvsp[-4].vector),
	    yyvsp[-2].real,
	    color,1,font,text,localProps,localComment,taglist,cblist);
	;}
    break;

  case 71:
#line 370 "prosparser.Y"
    {FR->createBoxCmd(Vector(yyvsp[-6].vector),
	    Vector(yyvsp[-4].vector),
	    yyvsp[-2].real,
	    color,1,font,text,localProps,localComment,taglist,cblist);;}
    break;

  case 72:
#line 376 "prosparser.Y"
    {	
	  aStatus = 4;
	  aVector[aNum++] = Vector(yyvsp[-13].vector);
	;}
    break;

  case 73:
#line 382 "prosparser.Y"
    {FR->createBoxCirclePointCmd(Vector(yyvsp[-2].vector),
	    color,1,font,text,localProps,localComment,taglist,cblist);;}
    break;

  case 74:
#line 385 "prosparser.Y"
    {polylist.deleteAll();;}
    break;

  case 75:
#line 386 "prosparser.Y"
    {FR->createPolygonCmd(polylist,
	    color,1,font,text,localProps,localComment,taglist,cblist);;}
    break;

  case 78:
#line 394 "prosparser.Y"
    {polylist.append(new Vertex(yyvsp[0].vector));;}
    break;

  case 81:
#line 401 "prosparser.Y"
    {aAnnuli[aNum++] = yyvsp[0].real;;}
    break;

  case 82:
#line 405 "prosparser.Y"
    {
	  switch (aStatus) {
	  case 0: // do nothing
	    break;
	  case 1: // we found just an ellipse, do nothing
	    break;
	  case 2: // ok we have an ellipse annulus
	    FR->markerDeleteLastCmd(); // delete the previous ellipse
	    FR->createEllipseAnnulusCmd(aCenter,
	      aNum,aVector,
	      aAngle,
	      color,1,font,text,aProps,aComment,taglist,cblist);
	    break;
	  case 3: // we found just a box, do nothing
	    break;
	  case 4: // ok, we have a box annulus
	    FR->markerDeleteLastCmd(); // delete the previous box
	    FR->createBoxAnnulusCmd(aCenter,
	      aNum,aVector,
	      aAngle,
	      color,1,font,text,aProps,aComment,taglist,cblist);
	    break;
	  }
	  aStatus = 0;
	;}
    break;

  case 84:
#line 433 "prosparser.Y"
    {DISCARD_(1);}
    break;

  case 86:
#line 436 "prosparser.Y"
    {DISCARD_(1);}
    break;

  case 89:
#line 440 "prosparser.Y"
    {DISCARD_(0);}
    break;

  case 90:
#line 441 "prosparser.Y"
    {strncpy(localComment,yyvsp[-1].str,80);;}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 1760 "prosparser.C"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 444 "prosparser.Y"


static void setProps(unsigned short* props, unsigned short prop, int value)
{
  if (value)
    *props |= prop;
  else
    *props &= ~prop;
}

static CoordSystem checkWCSSystem()
{
  switch (localSystem) {
  case IMAGE:
  case PHYSICAL:
    return WCS;
  default:
    return localSystem;
  }
}

static SkyFrame checkWCSSky()
{
  switch (localSystem) {
  case IMAGE:
  case PHYSICAL:
    return NATIVEWCS;
  default:
   return localSky;
  }
}

